import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.concurrent.TimeUnit;
import javax.imageio.ImageIO;
import org.openqa.selenium.Capabilities;
import org.openqa.selenium.OutputType;
import org.openqa.selenium.TakesScreenshot;
import org.openqa.selenium.phantomjs.PhantomJSDriver;
import org.openqa.selenium.phantomjs.PhantomJSDriverService;
import org.openqa.selenium.remote.DesiredCapabilities;

public class EBestPhantomNewSSLTest {

	public static void main(String[] args) {
		// TODO Auto-generated method stub

    String phantomPath = "/cont01/TEST/phantomjs";
    
    try {
    	
    	String testUrl = "https://ebest-api-v2.renaultsamsungm.com";
    	
    	if(args.length>0) {
    		if (args[0].equals("dev")) {
    			testUrl = "https://ebest-api-dev.renaultsamsungM.com";
    		}else if (args[0].equals("devip")) {
    			testUrl = "http://172.20.20.211:8280";
    		}else if (args[0].equals("albip")) {
    			testUrl = "https://13.209.100.193";
    		}else if (args[0].equals("was1")) {
    			testUrl = "http://172.10.21.203:8180";
    		}else if (args[0].equals("was2")) {
    			testUrl = "http://172.10.20.30:8180";
    		}
    	}
    	
    	String testPage = "/form/preview/simple/pk12493__00_1";
    	
//      DesiredCapabilities dCaps = new DesiredCapabilities();
      
      DesiredCapabilities dCaps = DesiredCapabilities.phantomjs();
      dCaps.setJavascriptEnabled(true);
      dCaps.setCapability("phantomjs.binary.path", phantomPath);
      dCaps.setCapability(PhantomJSDriverService.PHANTOMJS_CLI_ARGS, new String[] {"--web-security=no", "--ignore-ssl-errors=yes", "--ssl-protocol=tlsv1.2"});
//      driver = new PhantomJSDriver(dCaps);      
      
//      dCaps.setJavascriptEnabled(true);
//      dCaps.setCapability("phantomjs.binary.path", phantomPath);
      
      ArrayList<String> cliArgs = new ArrayList<>();
      
      PhantomJSDriver phantomJSDriver = new PhantomJSDriver((Capabilities)dCaps);
      phantomJSDriver.manage().timeouts().implicitlyWait(30L, TimeUnit.SECONDS);
      
      String baseUrl = testUrl + testPage;
      
      System.out.println("------------------------------------------------");
      System.out.println("1111 : " + baseUrl);
      System.out.println("------------------------------------------------");
      phantomJSDriver.get(baseUrl);
      System.out.println("------------------------------------------------");
      System.out.println("2222 : " + baseUrl);
      System.out.println("------------------------------------------------");
      
      BufferedImage bi = null;
      InputStream in = null;
      try {
        long iStart = System.currentTimeMillis();
        byte[] screenShotByte = (byte[])((TakesScreenshot)phantomJSDriver).getScreenshotAs(OutputType.BYTES);
        in = new ByteArrayInputStream(screenShotByte);
        System.out.println("Buffered Image [ : " + (System.currentTimeMillis() - iStart) + " ]");
        bi = ImageIO.read(in);
      } catch (IOException e) {
        e.printStackTrace();
        throw e;
      } finally {
        if (in != null)
          try {
            in.close();
          } catch (Exception exception) {} 
      } 
      System.out.println("------------------------------------------------");
      System.out.println("------------------------------------------------");
      System.out.println("------------------------------------------------");
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
}

